Index: /anuga_work/production/patong/asc2raster_WGS84z47N.py
===================================================================
--- /anuga_work/production/patong/asc2raster_WGS84z47N.py	(revision 6027)
+++ /anuga_work/production/patong/asc2raster_WGS84z47N.py	(revision 6028)
@@ -26,5 +26,5 @@
 
 
-time_dir1 = '20081113_153848_run_final_0_kvanputt'
+time_dir1 = '20081117_142008_run_final_0_kvanputt'
 
 time_dirs = [time_dir1]
@@ -38,5 +38,5 @@
     
     # Process: Create File GDB...
-    gp.CreateFileGDB_management(folder, "raster")
+   # gp.CreateFileGDB_management(folder, "raster")
 
     gp.Workspace = raster_gbd
@@ -49,5 +49,5 @@
 
     generate_filename = []
-    input_ascii = glob.glob(folder + '*.asc')
+    input_ascii = glob.glob(folder + '*ion.asc')
 
     for infile in input_ascii:
Index: /anuga_work/production/patong/build_patong.py
===================================================================
--- /anuga_work/production/patong/build_patong.py	(revision 6027)
+++ /anuga_work/production/patong/build_patong.py	(revision 6028)
@@ -82,5 +82,6 @@
 
 print 'clipping outside extents'
-G3_clip1 = G3.clip_outside(project.extent_elev_dir1, verbose=True) 
+G1_clip = G1.clip(project.extent_elev_dir4, verbose=True) 
+G3_clip1 = G3.clip_outside(project.extent_elev_dir4, verbose=True) 
 G3_clip2 =G3_clip1.clip_outside(project.extent_elev_dir2, verbose=True)
 G4_clip = G4.clip_outside(project.extent_elev_dir3, verbose=True)
@@ -88,5 +89,5 @@
 #print 'hello', dir(G3_clip1), dir(G3_clip1), dir(G4_clip)
 print'add all geospatial objects'
-G = G1 + G2 + G3_clip1 + G3_clip2 + G4_clip
+G = G1_clip + G2 + G3_clip1 + G3_clip2 + G4_clip
 
 print'clip combined geospatial object by bounding polygon'
Index: /anuga_work/production/patong/export_results_max.py
===================================================================
--- /anuga_work/production/patong/export_results_max.py	(revision 6027)
+++ /anuga_work/production/patong/export_results_max.py	(revision 6028)
@@ -13,12 +13,12 @@
 import project, os
 import sys
+from anuga.lib.maxasc.maxasc import MaxAsc
 from anuga.shallow_water.data_manager import convert_dem_from_ascii2netcdf, dem2pts
 from anuga.shallow_water.data_manager import sww2dem
 from os import sep
-import maxasc
 
 directory = project.output_dir
 
-time_dir1 = '20081113_153848_run_final_0_kvanputt'
+time_dir1 = '20081126_141801_run_final_0.8_kvanputt'
 
 time_dirs = [time_dir1]
@@ -49,5 +49,5 @@
 
 # one or more key strings from var_equations above
-var = ['stage', 'elevation']
+var = ['stage', 'elevation', 'depth', 'speed']
 
 ######
@@ -110,3 +110,3 @@
 ##            print 'asc_name ', str(asc_name)
 ##            
-##            maxasc.MaxAsc(maxasc_outname, asc_name)
+##            MaxAsc(maxasc_outname, asc_name)
Index: /anuga_work/production/patong/project.py
===================================================================
--- /anuga_work/production/patong/project.py	(revision 6027)
+++ /anuga_work/production/patong/project.py	(revision 6028)
@@ -42,5 +42,5 @@
 # Model specific parameters. One or all can be changed each time the
 # run_scenario script is executed
-tide = 0               #0.8
+tide = 0.8               #0.8
 alpha = 0.1             # smoothing parameter for mesh
 friction=0.01           # manning's friction coefficient
@@ -163,4 +163,5 @@
 extent_elev_dir2 = read_polygon(polygons_dir + 'saddle_10m.txt')
 extent_elev_dir3 = read_polygon(polygons_dir + 'patong_1s.txt')
+extent_elev_dir4 = read_polygon(polygons_dir + 'patong_10m_aos.txt')
 
 #Land, to set the initial stage/water to be offcoast only
@@ -179,6 +180,11 @@
 res_aos1 = 1000*res_factor
 
+# Area of Shallow water and coastal land that needs a finer res than 1000000
+poly_sw = read_polygon(polygons_dir+'sw.csv')
+res_sw = 2000*res_factor
+
 # Combined all regions, must check that all are included!
-interior_regions = [[poly_aoi1,res_aoi1],[poly_aos1,res_aos1]]
+interior_regions = [[poly_aoi1,res_aoi1],[poly_aos1,res_aos1]
+                    ,[poly_sw,res_sw]]
                  
     
Index: /anuga_work/production/patong/run_patong.py
===================================================================
--- /anuga_work/production/patong/run_patong.py	(revision 6027)
+++ /anuga_work/production/patong/run_patong.py	(revision 6028)
@@ -224,4 +224,5 @@
     
     kwargs={}
+    kwargs['file_name']=project.dir_comment
     kwargs['finaltime']=project.finaltime
     kwargs['output_dir']=project.output_run_time_dir