Index: /anuga_work/production/busselton/asc2raster_GDA94z50.py
===================================================================
--- /anuga_work/production/busselton/asc2raster_GDA94z50.py	(revision 6062)
+++ /anuga_work/production/busselton/asc2raster_GDA94z50.py	(revision 6063)
@@ -25,13 +25,16 @@
 output_dir="anuga\\outputs\\"
 
+##time_dir1 = '20081209_155610_run_final_0_27255_250m_none_lfountai'
+##time_dir2 = '20081209_160607_run_final_0_68693_250m_none_lfountai'
 
-time_dir1 = '20081009_184721_run_final_0.6_68693_alpha0.1_kvanputt'
+
+##time_dir1 = '20081009_184721_run_final_0.6_68693_alpha0.1_kvanputt'
 time_dir2 = '20081031_120515_run_final_0_27255_alpha0.1_kvanputt'
-time_dir3 = '20081031_120753_run_final_0.6_27283_alpha0.1_kvanputt'
-time_dir4 = '20081031_120642_run_final_0_27283_alpha0.1_kvanputt'
+##time_dir3 = '20081031_120753_run_final_0.6_27283_alpha0.1_kvanputt'
+##time_dir4 = '20081031_120642_run_final_0_27283_alpha0.1_kvanputt'
 time_dir5 = '20081031_120316_run_final_0_68693_alpha0.1_kvanputt'
-time_dir6 = '20081111_113832_run_final_0.6_27255_alpha0.1_kvanputt'
+##time_dir6 = '20081111_113832_run_final_0.6_27255_alpha0.1_kvanputt'
 
-time_dirs = [time_dir6] #1, time_dir2, time_dir3, time_dir4, time_dir5]
+time_dirs = [time_dir2, time_dir5]#, time_dir3, time_dir4, time_dir5, time_dir6]
  
 for time_dir in time_dirs:
@@ -41,20 +44,22 @@
     raster_gbd = folder + 'raster.gdb'
     land = scenario_dir + "map_work\\Busselton.gdb\\Internal_polygons\\initial_conditions_extend"
+    ocean = scenario_dir + "map_work\\Busselton.gdb\\input_boundaries\\Ocean"
 
-    # Process: Create File GDB...
-    gp.CreateFileGDB_management(folder, "raster")
+    
+##    print 'Process: Create File GDB'
+##    gp.CreateFileGDB_management(folder, "raster")
 
     gp.Workspace = raster_gbd
 
-    #print gp.Workspace
+    print time_dir
     
     #replication dictionary
-    replicate = (('busselton', ''),('_', ''),('max','M_'),
+    replicate = (('busselton', ''),('_', ''),('max','_M'),
                  ('Busselton', 'Bus'),('Bunbury', 'Bun'),
                  ('depth','_dep_'),('speed', '_spe_'),
-                 ('elevation', '_ele_'), ('stage','_sta_'))
+                 ('elevation', '_ele_'), ('stage','_stage'))
 
     generate_filename = []
-    input_ascii = glob.glob(folder + '*max.asc')
+    input_ascii = glob.glob(folder + '*stage_max.asc')
 
     for infile in input_ascii:
@@ -69,6 +74,4 @@
 
         print 'Output DEM ',output_DEM
-        output_extract = output_DEM + 'E'
-        print 'Output Extract ',output_extract
         
         print 'Process: ASCII to Raster'
@@ -79,7 +82,8 @@
                                                    ",PROJECTION['Transverse_Mercator'],PARAMETER['False_Easting',500000.0],PARAMETER['False_Northing',10000000.0],PARAMETER['Central_Meridian',117.0],PARAMETER['Scale_Factor',0.9996]"
                                                    ",PARAMETER['Latitude_Of_Origin',0.0],UNIT['Meter',1.0]]")
-
-        print 'Process: Extract by Mask'
-        gp.ExtractByMask_sa(output_DEM, land, output_extract)
+##        output_extract = output_DEM + 'E'
+##        print 'Output Extract ',output_extract
+##        print 'Process: Extract by Mask'
+##        gp.ExtractByMask_sa(output_DEM, ocean, output_extract)
 
 
Index: /anuga_work/production/busselton/export_results_max.py
===================================================================
--- /anuga_work/production/busselton/export_results_max.py	(revision 6062)
+++ /anuga_work/production/busselton/export_results_max.py	(revision 6063)
@@ -21,22 +21,23 @@
 directory = project.output_dir
 
-#time_dir1 = '20081031_133841_run_final_0_27283_alpha0.1_kvanputt'
-#time_dir1 = '20080924_123626_run_final_0_27283_250m_all_kvanputt' # This uses the 250m bathymetry with all interior polygons
-#time_dir2 = '20080912_154716_run_final_0_27283_alpha0.1_kvanputt' # This uses original bathyemetry data
-#time_dir3 = '20080924_123601_run_final_0_27283_250m_none_kvanputt' # This uses the 250m bathymetry without any interior polygons
-#time_dirs = [time_dir1] #, time_dir2]#, time_dir3]
+##time_dir1 = '20081209_155610_run_final_0_27255_250m_none_lfountai'
+##time_dir2 = '20081209_160607_run_final_0_68693_250m_none_lfountai'
+###time_dir1 = '20080924_123626_run_final_0_27283_250m_all_kvanputt' # This uses the 250m bathymetry with all interior polygons
+###time_dir2 = '20080912_154716_run_final_0_27283_alpha0.1_kvanputt' # This uses original bathyemetry data
+###time_dir3 = '20080924_123601_run_final_0_27283_250m_none_kvanputt' # This uses the 250m bathymetry without any interior polygons
+##time_dirs = [time_dir1, time_dir2]#, time_dir3]
 
-time_dir1 = '20081009_184721_run_final_0.6_68693_alpha0.1_kvanputt'
+##time_dir1 = '20081009_184721_run_final_0.6_68693_alpha0.1_kvanputt'
 time_dir2 = '20081031_120515_run_final_0_27255_alpha0.1_kvanputt'
-time_dir3 = '20081031_120753_run_final_0.6_27283_alpha0.1_kvanputt'
-time_dir4 = '20081031_120642_run_final_0_27283_alpha0.1_kvanputt'
+##time_dir3 = '20081031_120753_run_final_0.6_27283_alpha0.1_kvanputt'
+##time_dir4 = '20081031_120642_run_final_0_27283_alpha0.1_kvanputt'
 time_dir5 = '20081031_120316_run_final_0_68693_alpha0.1_kvanputt'
-time_dir6 = '20081111_113832_run_final_0.6_27255_alpha0.1_kvanputt'
-
-time_dirs = [time_dir6] #1, time_dir2, time_dir3, time_dir4, time_dir5]
+##time_dir6 = '20081111_113832_run_final_0.6_27255_alpha0.1_kvanputt'
+##
+time_dirs = [time_dir2, time_dir5]# , time_dir3, time_dir4, time_dir5, time_dir6]
   
 
-cellsize = 20
-#cellsize = 250
+#cellsize = 20
+cellsize = 250
 
 timestep = None    # None means no timestep!
@@ -47,6 +48,6 @@
 ######
 
-area = ['Bunbury', 'Busselton']  # strings must match keys in var_equations below
-#area = ['All']      # 'All' means no special areas - the whole thing
+#area = ['Bunbury', 'Busselton']  # strings must match keys in var_equations below
+area = ['All']      # 'All' means no special areas - the whole thing
 
 ######
@@ -61,5 +62,5 @@
 
 # one or more key strings from var_equations above
-var = ['depth', 'speed']
+var = ['stage']
 
 ######
Index: /anuga_work/production/busselton/get_timeseries.py
===================================================================
--- /anuga_work/production/busselton/get_timeseries.py	(revision 6062)
+++ /anuga_work/production/busselton/get_timeseries.py	(revision 6063)
@@ -18,35 +18,19 @@
 directory = project.output_dir
 
-##time_dir1 = '20081009_184721_run_final_0.6_68693_alpha0.1_kvanputt'
-##time_dir2 = '20081031_120515_run_final_0_27255_alpha0.1_kvanputt'
-time_dir3 = '20081031_120753_run_final_0.6_27283_alpha0.1_kvanputt'
-##time_dir4 = '20081031_120642_run_final_0_27283_alpha0.1_kvanputt'
-##time_dir5 = '20081031_120316_run_final_0_68693_alpha0.1_kvanputt'
-##time_dir6 = '20081111_113832_run_final_0.6_27255_alpha0.1_kvanputt'
+time_dir1 = '20081009_184721_run_final_0.6_68693_alpha0.1_kvanputt'+sep+'gauge'
+time_dir2 = '20081031_120316_run_final_0_68693_alpha0.1_kvanputt'+sep+'gauge'
+time_dir3 = '20081031_120515_run_final_0_27255_alpha0.1_kvanputt'+sep+'gauge'
+time_dir4 = '20081031_120642_run_final_0_27283_alpha0.1_kvanputt'+sep+'gauge'
+time_dir5 = '20081031_120753_run_final_0.6_27283_alpha0.1_kvanputt'+sep+'gauge'
+time_dir6 = '20081111_113832_run_final_0.6_27255_alpha0.1_kvanputt'+sep+'gauge'
 
-time_dirs = [time_dir3] #1, time_dir2, time_dir3, time_dir4, time_dir5, time_dir6]
+time_dirs = [time_dir1, time_dir2, time_dir3, time_dir4, time_dir5, time_dir6]
 
 for time_dir in time_dirs:
-    
-    name1 = directory+time_dir+sep+project.scenario_name
-    #name2 = directory+time_dir+sep+project.scenario_name+'_time_39600_0'
-    #name3 = directory+time_dir+sep+project.scenario_name+'_time_79200_0'
+    name = directory+time_dir+sep+project.scenario_name 
+    gauge = project.gauges_dir_name
+    sww2csv_gauges(name+'.sww',gauge,
+                   quantities = ['stage','speed','depth','elevation'],
+                   verbose=True)
+  
 
-    names = [name1] #, name2, name3]
-
-    for i, name in enumerate(names):
-        gauge = project.gauges_dir_name
-                  
-        sww2csv_gauges(name+'.sww',gauge,
-                        quantities = ['stage','speed','depth','elevation'],
-                        verbose=True)
-##        for filename in listdir(time_dir):
-##            total_filename = 'All_' + filename
-##            if i == 0:
-##                if filename.startswith('gauge_'):
-##                    rename(filename,total_filename)
-##            else:
-##                system('cat %s %s > %s' %(total_filename,filename,total_filename))
-##
-       
-
Index: /anuga_work/production/busselton/run_building_inundation.py
===================================================================
--- /anuga_work/production/busselton/run_building_inundation.py	(revision 6062)
+++ /anuga_work/production/busselton/run_building_inundation.py	(revision 6063)
@@ -37,5 +37,8 @@
 
 for time_dir in time_dirs:
-    building_marker = '_modified'
+    
+    time_dir_name = time_dir[-25:][:-18]
+       
+    building_marker = '_m_'+ time_dir_name
     name = directory+time_dir+sep+project.scenario_name #basename for the sww files 
     
@@ -44,5 +47,5 @@
     
     building_marker_dir_name = project.gauges_dir + project.building + building_marker + '.csv'
-    out_file = directory+time_dir+ sep+project.scenario_name+'_res.csv'
+    out_file = directory+time_dir+ sep+'busselton_res.csv'
     print 'out file %s' %out_file
     print 'building_marker_dir_name %s' %building_marker_dir_name
@@ -56,4 +59,6 @@
        newline = record[-8:]
        newline.insert(0,record[0])
+       newline.insert(1,record[1])
+       newline.insert(2,record[2])
        writer.writerow(newline)
        